=== debian/changelog ===
wabt (1.0.30-1) unstable; urgency=medium

  * New upstream version 1.0.30.

 -- Markus Koschany <apo@debian.org>  Thu, 13 Oct 2022 23:23:14 +0200
