## wabt 1.0.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.30)
+project(WABT LANGUAGES C CXX VERSION 1.0.31)
 
 include(GNUInstallDirs)
 
@@ -227,6 +227,25 @@
 endif ()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)
+
+# CWriter code templates
+set(TEMPLATE_CMAKE ${WABT_SOURCE_DIR}/scripts/gen-wasm2c-templates.cmake)
+
+add_custom_command(
+  OUTPUT wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc
+
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_top.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.top.h" -D symbol="s_header_top" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_bottom.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h" -D symbol="s_header_bottom" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
+
+  DEPENDS ${WABT_SOURCE_DIR}/src/template/wasm2c.top.h
+  ${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h
+  ${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c
+  ${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c
+)
+
+set(CWRITER_TEMPLATE_SRC wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc)
 
 add_custom_target(everything)
 
@@ -269,6 +288,8 @@
   src/wast-lexer.cc
   src/wast-parser.cc
   src/wat-writer.cc
+  src/c-writer.cc
+  ${CWRITER_TEMPLATE_SRC}
 
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.cc
@@ -328,54 +349,3 @@
   include/wabt/interp/interp-math.h
   include/wabt/interp/interp-util.h
   include/wabt/interp/interp.h
-  include/wabt/interp/istream.h
-)
-
-set(WABT_LIBRARY_SRC ${WABT_LIBRARY_CC} ${WABT_LIBRARY_H})
-
-add_library(wabt STATIC ${WABT_LIBRARY_SRC})
-add_library(wabt::wabt ALIAS wabt)
-
-target_compile_features(wabt PUBLIC cxx_std_17)
-target_include_directories(
-  wabt
-  PUBLIC
-  "$<BUILD_INTERFACE:${WABT_SOURCE_DIR}/include>"
-  "$<BUILD_INTERFACE:${WABT_BINARY_DIR}/include>"
-)
-
-if (WABT_INSTALL_RULES)
-  install(
-    TARGETS wabt EXPORT wabt-targets
-    COMPONENT wabt-development
-    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-  )
-  install(
-    DIRECTORY "${WABT_SOURCE_DIR}/include/" "${WABT_BINARY_DIR}/include/"
-    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-    COMPONENT wabt-development
-  )
-endif ()
-
-IF (NOT WIN32)
-  add_library(wasm-rt-impl STATIC wasm2c/wasm-rt-impl.c wasm2c/wasm-rt-impl.h)
-  add_library(wabt::wasm-rt-impl ALIAS wasm-rt-impl)
-  if (WABT_BIG_ENDIAN)
-    target_compile_definitions(wasm-rt-impl PUBLIC WABT_BIG_ENDIAN=1)
-  endif ()
-
-  if (WABT_INSTALL_RULES)
-    install(
-      TARGETS wasm-rt-impl
-      EXPORT wabt-targets
-      COMPONENT wabt-development
-      INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-    )
-    install(
-      FILES "wasm2c/wasm-rt-impl.h" "wasm2c/wasm-rt.h"
-      TYPE INCLUDE
-      COMPONENT wabt-development
-    )
-  endif ()
-endif ()
-
