=== debian/changelog ===
wabt (1.0.31-1) unstable; urgency=medium

  * New upstream version 1.0.31.

 -- Markus Koschany <apo@debian.org>  Mon, 28 Nov 2022 22:31:48 +0100
