## wabt 1.0.32

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.31)
+project(WABT LANGUAGES C CXX VERSION 1.0.32)
 
 include(GNUInstallDirs)
 
@@ -110,6 +110,10 @@
 
 include(TestBigEndian)  # Note: deprecated in CMake 3.20
 test_big_endian(WABT_BIG_ENDIAN)
+
+if (CMAKE_BUILD_TYPE STREQUAL "Debug")
+  set(WABT_DEBUG 1)
+endif ()
 
 configure_file(src/config.h.in include/wabt/config.h @ONLY)
 
@@ -347,5 +351,3 @@
   include/wabt/interp/binary-reader-interp.h
   include/wabt/interp/interp-inl.h
   include/wabt/interp/interp-math.h
-  include/wabt/interp/interp-util.h
-  include/wabt/interp/interp.h
