=== debian/changelog ===
wabt (1.0.32-1) unstable; urgency=medium

  * New upstream version 1.0.32.
  * Declare compliance with Debian Policy 4.6.2.

 -- Markus Koschany <apo@debian.org>  Fri, 13 Jan 2023 00:05:45 +0100
