## wabt 1.0.33

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.32)
+project(WABT LANGUAGES C CXX VERSION 1.0.33)
 
 include(GNUInstallDirs)
 
@@ -69,6 +69,7 @@
 # WASI support is still a work in progress.
 # Only a handful of syscalls are supported at this point.
 option(WITH_WASI "Build WASI support via uvwasi" OFF)
+option(USE_INTERNAL_SHA256 "Use internal PicoSHA2 for SHA-256 support instead of OpenSSL libcrypto" OFF)
 
 if (MSVC)
   set(COMPILER_IS_CLANG 0)
@@ -100,7 +101,23 @@
 check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
 check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)
 
+if (NOT USE_INTERNAL_SHA256)
+  find_package(OpenSSL QUIET)
+  if (OpenSSL_FOUND)
+    set(CMAKE_REQUIRED_INCLUDES ${OPENSSL_INCLUDE_DIR})
+    check_include_file("openssl/sha.h" HAVE_OPENSSL_SHA_H)
+    if (HAVE_OPENSSL_SHA_H)
+      find_package_message(OpenSSL "Using OpenSSL libcrypto for SHA-256" "${HAVE_OPENSSL_SHA_H}")
+    endif()
+  endif()
+endif()
+
 if (WIN32)
+  if(${CMAKE_GENERATOR_PLATFORM} MATCHES "ARM64")
+    # https://discourse.cmake.org/t/visual-studio-error-unable-to-deploy-local-file-c-x64-release-zero-check/2072
+    # Target ZERO_CHECK blocks remote debugger of ARM64 in Visual Studio
+    set(CMAKE_SUPPRESS_REGENERATION ON)
+  endif()
   check_symbol_exists(ENABLE_VIRTUAL_TERMINAL_PROCESSING "windows.h" HAVE_WIN32_VT100)
 endif ()
 
@@ -147,7 +164,7 @@
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
   add_definitions(
-    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized
+    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized -Wimplicit-fallthrough
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
@@ -205,6 +222,7 @@
     set(USE_SANITIZER TRUE PARENT_SCOPE)
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}" PARENT_SCOPE)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
+    set(WASM2C_CFLAGS "${WASM2C_CFLAGS} ${FLAGS}" PARENT_SCOPE)
   endif ()
 endfunction()
 sanitizer(USE_ASAN "-fsanitize=address")
@@ -236,20 +254,29 @@
 set(TEMPLATE_CMAKE ${WABT_SOURCE_DIR}/scripts/gen-wasm2c-templates.cmake)
 
 add_custom_command(
-  OUTPUT wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc
-
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_top.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.top.h" -D symbol="s_header_top" -P ${TEMPLATE_CMAKE}
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_bottom.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h" -D symbol="s_header_bottom" -P ${TEMPLATE_CMAKE}
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
+  OUTPUT gen-wasm2c-prebuilt
+
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_top.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.top.h" -D symbol="s_header_top" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_bottom.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h" -D symbol="s_header_bottom" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c" -D symbol="s_simd_source_declarations" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -E touch gen-wasm2c-prebuilt
 
   DEPENDS ${WABT_SOURCE_DIR}/src/template/wasm2c.top.h
   ${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h
   ${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c
   ${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c
+  ${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c
 )
 
-set(CWRITER_TEMPLATE_SRC wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc)
+add_custom_target(gen-wasm2c-prebuilt-target DEPENDS gen-wasm2c-prebuilt)
+
+set(CWRITER_TEMPLATE_SRC ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_top.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_bottom.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc)
 
 add_custom_target(everything)
 
@@ -282,6 +309,7 @@
   src/opcode.cc
   src/option-parser.cc
   src/resolve-names.cc
+  src/sha256.cc
   src/shared-validator.cc
   src/stream.cc
   src/token.cc
@@ -293,61 +321,3 @@
   src/wast-parser.cc
   src/wat-writer.cc
   src/c-writer.cc
-  ${CWRITER_TEMPLATE_SRC}
-
-  # TODO(binji): Move this into its own library?
-  src/interp/binary-reader-interp.cc
-  src/interp/interp.cc
-  src/interp/interp-util.cc
-  src/interp/istream.cc
-)
-
-set(WABT_LIBRARY_H
-  ${WABT_BINARY_DIR}/include/wabt/config.h
-
-  include/wabt/apply-names.h
-  include/wabt/binary-reader-ir.h
-  include/wabt/binary-reader-logging.h
-  include/wabt/binary-reader.h
-  include/wabt/binary-writer-spec.h
-  include/wabt/binary-writer.h
-  include/wabt/binary.h
-  include/wabt/binding-hash.h
-  include/wabt/color.h
-  include/wabt/common.h
-  include/wabt/decompiler-ast.h
-  include/wabt/decompiler-ls.h
-  include/wabt/decompiler-naming.h
-  include/wabt/decompiler.h
-  include/wabt/error-formatter.h
-  include/wabt/expr-visitor.h
-  include/wabt/feature.h
-  include/wabt/filenames.h
-  include/wabt/generate-names.h
-  include/wabt/ir-util.h
-  include/wabt/ir.h
-  include/wabt/leb128.h
-  include/wabt/lexer-source-line-finder.h
-  include/wabt/lexer-source.h
-  include/wabt/literal.h
-  include/wabt/opcode-code-table.h
-  include/wabt/opcode.h
-  include/wabt/option-parser.h
-  include/wabt/resolve-names.h
-  include/wabt/shared-validator.h
-  include/wabt/stream.h
-  include/wabt/string-util.h
-  include/wabt/token.h
-  include/wabt/tracing.h
-  include/wabt/type-checker.h
-  include/wabt/type.h
-  include/wabt/utf8.h
-  include/wabt/validator.h
-  include/wabt/wast-lexer.h
-  include/wabt/wast-parser.h
-  include/wabt/wat-writer.h
-
-  # TODO(binji): Move this into its own library?
-  include/wabt/interp/binary-reader-interp.h
-  include/wabt/interp/interp-inl.h
-  include/wabt/interp/interp-math.h
