=== debian/changelog ===
wabt (1.0.33-1) unstable; urgency=medium

  * New upstream version 1.0.33.
  * Build-depend on libssl-dev to provide a SHA-256 implementation
    used by the wasm2c tool.

 -- Markus Koschany <apo@debian.org>  Sat, 01 Jul 2023 15:35:52 +0200
