## wabt 1.0.34

=== debian/changelog ===
wabt (1.0.34-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
    Changes-By: lintian-brush Fixes: lintian: trailing-whitespace See-also:
    https://lintian.debian.org/tags/trailing-whitespace.html
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing See-also:
    https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
    Fixes: lintian: upstream-metadata-missing-bug-tracking See-also:
    https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html

  [ Markus Koschany ]
  * Add clean file.
  * Remove the bin directory completely.
  * New upstream version 1.0.34.

 -- Markus Koschany <apo@debian.org>  Mon, 30 Oct 2023 23:28:18 +0100
