=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  cmake,
  debhelper-compat (= 13),
  python3,
+ libssl-dev,
  re2c
 Standards-Version: 4.6.2
 Homepage: https://github.com/WebAssembly/wabt
