## wabt 1.0.34%2Bdsfg2%2B~cs1.0.32

=== debian/changelog ===
wabt (1.0.34+dsfg2+~cs1.0.32-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:33:42 +1100

wabt (1.0.34+dsfg2+~cs1.0.32-1ubuntu1) noble; urgency=medium

  * Strip "-Wl,-Bsymbolic-functions", making build fail.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 27 Mar 2024 09:26:03 +0100

wabt (1.0.34+dsfg2+~cs1.0.32-1) unstable; urgency=medium

  * Repack in order to get rid of spurious tar
  * Upload to unstable

 -- Bastien Roucariès <rouca@debian.org>  Fri, 16 Feb 2024 18:44:56 +0000

wabt (1.0.34+dsfg+~cs1.0.32-1) experimental; urgency=medium

  [ Bastien Roucariès ]
  * Add Yadd and myself as comaintainer. Thanks Markus
  * Include picosha2 forgotten by upstream
  * Compile wabt.js
  * Add node package

  [ Yadd ]
  * Set upstream metadata fields: Security-Contact.
  * Add "Rules-Requires-Root: no"
  * Add ctype=nodejs to component(s)
  * Update debian/copyright
  * Improve hardening
  * Add lintian overrides
  * Add spelling error patch
  * Exclude fuzz-in/wasm/stuff.wasm and wasm2c/examples/fac/fac.wasm from import

 -- Bastien Roucariès <rouca@debian.org>  Tue, 05 Dec 2023 15:48:51 +0000
