## wabt 1.0.34+dsfg2+~cs1.0.32

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.33)
+project(WABT LANGUAGES C CXX VERSION 1.0.34)
 
 include(GNUInstallDirs)
 
@@ -98,6 +98,7 @@
 
 check_include_file("alloca.h" HAVE_ALLOCA_H)
 check_include_file("unistd.h" HAVE_UNISTD_H)
+check_include_file("setjmp.h" HAVE_SETJMP_H)
 check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
 check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)
 
@@ -261,6 +262,7 @@
   COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
   COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
   COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c" -D symbol="s_simd_source_declarations" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_atomicops_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c_atomicops.declarations.c" -D symbol="s_atomicops_source_declarations" -P ${TEMPLATE_CMAKE}
   COMMAND ${CMAKE_COMMAND} -E touch gen-wasm2c-prebuilt
 
   DEPENDS ${WABT_SOURCE_DIR}/src/template/wasm2c.top.h
@@ -268,6 +270,7 @@
   ${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c
   ${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c
   ${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c
+  ${WABT_SOURCE_DIR}/src/template/wasm2c_atomicops.declarations.c
 )
 
 add_custom_target(gen-wasm2c-prebuilt-target DEPENDS gen-wasm2c-prebuilt)
@@ -276,7 +279,8 @@
                          ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_bottom.cc
                          ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc
                          ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc
-                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc)
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_atomicops_source_declarations.cc)
 
 add_custom_target(everything)
 
@@ -298,26 +302,3 @@
   src/expr-visitor.cc
   src/feature.cc
   src/filenames.cc
-  src/generate-names.cc
-  src/ir-util.cc
-  src/ir.cc
-  src/leb128.cc
-  src/lexer-source-line-finder.cc
-  src/lexer-source.cc
-  src/literal.cc
-  src/opcode-code-table.c
-  src/opcode.cc
-  src/option-parser.cc
-  src/resolve-names.cc
-  src/sha256.cc
-  src/shared-validator.cc
-  src/stream.cc
-  src/token.cc
-  src/tracing.cc
-  src/type-checker.cc
-  src/utf8.cc
-  src/validator.cc
-  src/wast-lexer.cc
-  src/wast-parser.cc
-  src/wat-writer.cc
-  src/c-writer.cc
