=== wasm2c/examples/fac/Makefile ===
--- 
+++ 
@@ -12,6 +12,6 @@
 	../../../bin/wat2wasm $< -o $@
 
 fac.c: fac.wasm ../../../bin/wasm2c
-	../../../bin/wasm2c $< -o $@
+	../../../bin/wasm2c $< -o $@ --disable-simd
 
 .PHONY: all clean
