=== wasm2c/examples/rot13/Makefile ===
--- 
+++ 
@@ -14,6 +14,6 @@
 	../../../bin/wat2wasm $< -o $@
 
 rot13.c: rot13.wasm ../../../bin/wasm2c
-	../../../bin/wasm2c $< -o $@
+	../../../bin/wasm2c $< -o $@ --disable-simd
 
 .PHONY: all clean
