=== debian/control ===
--- 
+++ 
@@ -1,23 +1,29 @@
 Source: wabt
 Section: devel
 Priority: optional
-Maintainer: Markus Koschany <apo@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 13),
- python3,
- libssl-dev,
- re2c
+Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Uploaders: Markus Koschany <apo@debian.org>
+ , Bastien Roucariès <rouca@debian.org>
+ , Yadd <yadd@debian.org>
+Build-Depends: debhelper-compat (= 13)
+ , cmake
+ , dh-nodejs
+ , emscripten
+ , libssl-dev
+ , ninja-build
+ , python3
+ , re2c
 Standards-Version: 4.6.2
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt
+Rules-Requires-Root: no
 
 Package: wabt
 Architecture: any
-Depends:
- ${misc:Depends},
- ${shlibs:Depends}
+Depends: ${misc:Depends}
+ , ${shlibs:Depends}
+Provides: ${nodejs:Provides}
 Description: WebAssembly Binary Toolkit
  WABT (pronounced: "wabbit") is a suite of tools for WebAssembly, including:
  .
